;; -*- lexical-binding: t -*-

(defvar my-read-expression-map
  (let ((map (make-sparse-keymap)))
    (set-keymap-parent map read-expression-map)
    (define-key map "\C-g" #'abort-minibuffers)
    (define-key map [up]   nil)
    (define-key map [down] nil)
    (define-key map "\C-j" #'newline)
    (define-key map "\r"   #'exit-minibuffer)
    (define-key map "\n"   #'exit-minibuffer)
    map))

(defun my-read-expression
    (prompt &optional initial-contents hist default read map)
  "Like `read-expression' but using emacs-lisp-mode like minibuffer."
  (minibuffer-with-setup-hook #'my-read-expression-setup-minibuffer
    (read-from-minibuffer prompt initial-contents
                          (or map my-read-expression-map) read
                          (or hist 'read-expression-history) default)))

(defun my-read-expression-setup-minibuffer ()
  (let ((inhibit-read-only t))
    ;; Without this the prompt would be painted like code
    (put-text-property 1 (minibuffer-prompt-end) 'font-lock-face 'minibuffer-prompt))
  (emacs-lisp-mode)
  (use-local-map my-read-expression-map)
  (setq font-lock-mode t)
  (funcall font-lock-function 1)
  (goto-char (minibuffer-prompt-end))
  (when (looking-at ".*\n")
    (indent-sexp))
  (goto-char (point-max)))
